barp4d <- function (height, trait = names(tdata(height)), center = TRUE, 
    scale = TRUE, tree.ladderize = FALSE, tree.type = "phylogram", 
    tree.ratio = NULL, tree.xlim = NULL, tree.open.angle = 0, 
    tree.open.crown = TRUE, show.tip = TRUE, tip.labels = NULL, 
    tip.col = "black", tip.cex = 1, tip.font = 3, tip.adj = 0, 
    data.xlim = NULL, bar.lwd = 10, bar.col = "grey35", 
    show.data.axis = TRUE, show.trait = TRUE, trait.labels = NULL, 
    trait.col = "black", trait.cex = 1, trait.font = 1, 
    trait.bg.col = "grey90", error.bar.sup = NULL, error.bar.inf = NULL, 
    error.bar.col = 1, show.box = FALSE, grid.vertical = TRUE, 
    grid.horizontal = FALSE, grid.col = "grey25", grid.lty = "dashed", 
    ...) 
{
    plot.phylo4d(x = height, trait = trait, center = center, 
        scale = scale, plot.type = "barplot", tree.ladderize = tree.ladderize, 
        tree.type = tree.type, tree.ratio = tree.ratio, tree.xlim = tree.xlim, 
        tree.open.angle = tree.open.angle, tree.open.crown = tree.open.crown, 
        show.tip = show.tip, tip.labels = tip.labels, tip.col = tip.col, 
        tip.cex = tip.cex, tip.font = tip.font, tip.adj = tip.adj, 
        data.xlim = data.xlim, bar.lwd = bar.lwd, bar.col = bar.col, 
        show.data.axis = show.data.axis, show.trait = show.trait, 
        trait.labels = trait.labels, trait.col = trait.col, trait.cex = trait.cex, 
        trait.font = trait.font, trait.bg.col = trait.bg.col, 
        error.bar.sup = error.bar.sup, error.bar.inf = error.bar.inf, 
        error.bar.col = error.bar.col, show.box = show.box, grid.vertical = grid.vertical, 
        grid.horizontal = grid.horizontal, grid.col = grid.col, 
        grid.lty = grid.lty, ...)
}
